# Copyright (c) 2017, InfluxFrameworkand Contributors
# License: GNU General Public License v3. See license.txt


import influxframework

from influxerp.manufacturing.doctype.work_order.work_order import create_job_card


def execute():
	influxframework.reload_doc("manufacturing", "doctype", "work_order")
	influxframework.reload_doc("manufacturing", "doctype", "work_order_item")
	influxframework.reload_doc("manufacturing", "doctype", "job_card")
	influxframework.reload_doc("manufacturing", "doctype", "job_card_item")

	fieldname = influxframework.db.get_value(
		"DocField", {"fieldname": "work_order", "parent": "Timesheet"}, "fieldname"
	)
	if not fieldname:
		fieldname = influxframework.db.get_value(
			"DocField", {"fieldname": "production_order", "parent": "Timesheet"}, "fieldname"
		)
		if not fieldname:
			return

	for d in influxframework.get_all(
		"Timesheet", filters={fieldname: ["!=", ""], "docstatus": 0}, fields=[fieldname, "name"]
	):
		if d[fieldname]:
			doc = influxframework.get_doc("Work Order", d[fieldname])
			for row in doc.operations:
				create_job_card(doc, row, auto_create=True)
			influxframework.delete_doc("Timesheet", d.name)
